%module  SAS

%include "carrays.i"
%include "std_string.i"
%include "std_vector.i"
%include "std_pair.i"
%include "VectorDef.i"

%{
#include "Header.hh"
#include "MlfDetectorEfficiencyCorrection.hh"
#include "DetectorInfoEditorBase.hh"
#include "UtsusemiDetectorInfoEditorNeunet.hh"
#include "CreateLambVector.hh"
#include "ConvertToQspace.hh"
#include "ConvertToPoint.hh"
#include "SectorAverageByAngle.hh"
#include "SASCalcDetectorEffi.hh"
#include "DetectorEffiCorrection.hh"
#include "SASDetectorEfficiencyCorrection.hh"
#include "I0LambdaCorrection.hh"
#include "TransmittanceCorrection.hh"
#include "EcmSubtraction.hh"
#include "QzProjection.hh"
#include "CorrectEventRPMT.hh"
#include "DetectorEffiCorrectionRPMT.hh"
#include "CalcAzimuthProfile.hh"
#include "RPMTDataConverter.hh"
#include "IncohCalcFor3HeSpinFilter.hh"
#include "CalcScanTrajectory.hh"
#include "P0LambdaCorrection.hh"
#include "TreatQhklWithUB.hh"
#include "LambdaDependCorrection.hh"
#include "SASDetectorInfoEditorRPMT.hh"
#include "RPMTSetMaskBy2theta.hh"
%}

%include "DoxySwig.i"
%include "TemplateDef.i"

%include "Header.hh"
%include "MlfDetectorEfficiencyCorrection.hh"
%include "DetectorInfoEditorBase.hh"
%include "UtsusemiDetectorInfoEditorNeunet.hh"
%include "CreateLambVector.hh"
%include "ConvertToQspace.hh"
%include "ConvertToPoint.hh"
%include "SectorAverageByAngle.hh"
%include "SASCalcDetectorEffi.hh"
%include "DetectorEffiCorrection.hh"
%include "SASDetectorEfficiencyCorrection.hh"
%include "I0LambdaCorrection.hh"
%include "TransmittanceCorrection.hh"
%include "EcmSubtraction.hh"
%include "QzProjection.hh"
%include "CorrectEventRPMT.hh"
%include "DetectorEffiCorrectionRPMT.hh"
%include "CalcAzimuthProfile.hh"
%include "RPMTDataConverter.hh"
%include "IncohCalcFor3HeSpinFilter.hh"
%include "CalcScanTrajectory.hh"
%include "P0LambdaCorrection.hh"
%include "TreatQhklWithUB.hh"
%include "LambdaDependCorrection.hh"
%include "SASDetectorInfoEditorRPMT.hh"
%include "RPMTSetMaskBy2theta.hh"

namespace std {
        %template(StringVector)  vector<string>;
        %template(Int2Vector)    vector<Int2>;
        %template(UInt2Vector)   vector<UInt2>;
        %template(Int4Vector)    vector<Int4>;
        %template(UInt4Vector)   vector<UInt4>;
        %template(Int8Vector)    vector<Int8>;
        %template(UInt8Vector)   vector<UInt8>;
        %template(FloatVector)   vector<Float>;
        %template(BoolVector)   vector<Bool>;
        %template(DoubleVector)  vector<Double>;
        %template(Int4VectorVector)  vector< vector<Int4> >;
        %template(UInt4VectorVector)  vector< vector<UInt4> >;
}
