%module  MLF
%include "carrays.i"
%include "std_string.i"
%include "std_vector.i"
%include "std_pair.i"
%include "VectorDef.i"

%{
#include "Header.hh"
#include "MlfHeader.hh"
#include "EventDataToHistogramBase.hh"
#include "EventDataMonitorBase.hh"
#include "GnuplotInterface.hh"
#include "OnLineGnuPlot.hh"
#include "T0TreatToolsBase.hh"
#include "ContainerViewer.hh"
#include "AcquireNeutronSourceInformationBase.hh"
#include "AcquireNeutronSourceInformationControlBase.hh"
#include "AcquireNeutronSourceTextInformation.hh"
#include "AcquireNeutronSourceImageInformation.hh"
#include "AverageElementContainerMatrix.hh"
#include "BoostXmlParser.hh"
#include "MlfPhysicalConstants.hh"
#include "MlfMatrixSlicer.hh"
#include "MlfArraySlicer.hh"
#include "AdvScatAbsoBodyManagerMLF.hh"
#include "MlfScatAbsoBodyManager.hh"
#include "MlfDetectorEfficiencyCorrection.hh"
#include "ArrayOperation.hh"

%}

%include "Header.hh"
%include "TemplateDef.i"

%include "DoxySwig.i"

%include "MlfHeader.hh"
%include "EventDataToHistogramBase.hh"
%include "EventDataMonitorBase.hh"
%include "GnuplotInterface.hh"
%include "OnLineGnuPlot.hh"
%include "T0TreatToolsBase.hh"
%include "ContainerViewer.hh"
%include "AcquireNeutronSourceInformationBase.hh"
%include "AcquireNeutronSourceInformationControlBase.hh"
%include "AcquireNeutronSourceTextInformation.hh"
%include "AcquireNeutronSourceImageInformation.hh"
%include "AverageElementContainerMatrix.hh"
%include "BoostXmlParser.hh"
%include "MlfPhysicalConstants.hh"
%include "MlfMatrixSlicer.hh"
%include "MlfArraySlicer.hh"
%include "AdvScatAbsoBodyManagerMLF.hh"
%include "MlfScatAbsoBodyManager.hh"
%include "MlfDetectorEfficiencyCorrection.hh"
%include "ArrayOperation.hh"

namespace std {
        %template(StringVector)  vector<string>;
        %template(Int2Vector)    vector<Int2>;
        %template(UInt2Vector)   vector<UInt2>;
        %template(Int4Vector)    vector<Int4>;
        %template(UInt4Vector)   vector<UInt4>;
        %template(Int8Vector)    vector<Int8>;
        %template(UInt8Vector)   vector<UInt8>;
        %template(FloatVector)   vector<Float>;
        %template(BoolVector)   vector<Bool>;
        %template(DoubleVector)  vector<Double>;
        %template(Int4VectorVector)  vector< vector<Int4> >;
        %template(UInt4VectorVector)  vector< vector<UInt4> >;
}
